import { AppStore } from "./AppStore";
export interface ServiceStoreMetadata<StateT> {
    path: string;
    initialState: StateT;
}
export declare class ServiceStore<StateT extends object> {
    private appStore;
    private listeners;
    private metadata;
    private pathResolver;
    constructor(metadata: ServiceStoreMetadata<StateT>);
    onAppStoreInitialized(appStore: AppStore<any>): void;
    subscribe(listener: (newState: StateT, oldState: StateT) => void): void;
    subscribeTo(path: string, listener: (newState, oldState) => void): void;
    subscribeTo1<K1 extends keyof StateT>(key1: K1, listener: (newState: StateT[K1], oldState: StateT[K1]) => void): void;
    subscribeTo2<K1 extends keyof StateT, K2 extends keyof StateT[K1]>(key1: K1, key2: K2, listener: (newState: StateT[K1][K2], oldState: StateT[K1][K2]) => void): void;
    getAppStore(): AppStore<any>;
    getMetadata(): ServiceStoreMetadata<StateT>;
    getState(): StateT;
    update(changes: Partial<StateT>): StateT;
    static create<StateT extends object>(path: string, initialState: StateT): ServiceStore<StateT>;
    private emit(newState, oldState);
    private ensureInitialized();
}
